-module(arbre).
-compile(export_all).

arbreVide() ->
    {arbre}.

arbreCons(Elem, Ag, Ad) ->
    {arbre, Elem, Ag, Ad}.
    
racine({arbre, Elem, _, _}) ->
    Elem ;
racine({arbre}) ->
    errorVide.

arbreDroit({arbre, _, _, Ad}) ->
    Ad ;
arbreDroit({arbre}) ->
    errorVide.

arbreGauche({arbre, _, Ag, _}) ->
    Ag ;
arbreGauche({arbre}) ->
    errorVide.

arbreEstVide({arbre}) ->
    true ;
arbreEstVide({arbre, _, _, _}) ->
    false.

arbreEstFeuille(A) ->
    not(arbreEstVide(A)) andalso arbreEstVide(arbreGauche(A)) andalso arbreEstVide(arbreDroit(A)).

